# Qi user guide

## Table of Contents

- 1 Introduction to Qi
- 2 Invoking qi
- 3 The qirc file
- 4 Packages
  - 4.1 Package conflicts
  - 4.2 Installing packages
  - 4.3 Removing packages
  - 4.4 Upgrading packages
    - 4.4.1 Package blacklist
- 5 Recipes
  - 5.1 Variables
  - 5.2 Special variables
  - 5.3 Writing recipes
  - 5.4 Building packages
  - 5.5 Variables from the environment
  - 5.6 The meta file
- 6 Order files
- 7 Creating packages
- 8 Examining packages
- 9 Qi exit status
- Index

This user guide is for Qi (version 2.4-rc3, 04 Feb 2021).

Copyright (C) 2019-2021 Matias Fonzo.

Qi’s home page can be found at https://www.dragora.org. Send bug reports or suggestions to dragora-users@nongnu.org.

## 1 Introduction to Qi

Qi is a simple but well-integrated package manager. It can create, install, remove, and upgrade software packages. Qi produces binary packages using recipes, which are files containing specific instructions to build each package from source. Qi can manage multiple packages under a single directory hierarchy. This method allows to maintain a set of packages and multiple versions of them. This means that Qi could be used as the main package manager or complement the existing one.

Qi offers a friendly command line interface, a global configuration file, a simple recipe layout to deploy software packages; also works with binary packages in parallel, speeding up installations and packages in production. The format used for packages is a simplified but safe POSIX pax archive compressed with lzip.

Qi is a modern (POSIX-compliant) shell script released under the terms of the GNU General Public License. There are only two major dependencies for the magic: graft(1) and tarlz(1), the rest is expected to be found in any Unix-like system.

## 2 Invoking qi

This chapter describes the synopsis for invoking Qi.

    Usage: qi COMMAND [OPTION...] [FILE]...

One mandatory command specifies the operation that ‘`qi`’ should perform, options are meant to detail how this operation should be performed during or after the process.

Qi supports the following commands:

`warn`

  Warn about files that will be installed.

`install`

  Install packages.

`remove`

  Remove packages.

`upgrade`

  Upgrade packages.

`extract`

  Extract packages for debugging purposes.

`create`

  Create a .tlz package from directory.

`build`

  Build packages using recipe names.

`order`

  Resolve build order through .order files

Options when installing, removing, or upgrading software packages:

`-f`
`--force`

  Force upgrade of pre-existing packages.

`-k`
`--keep`

  Keep directories when build/remove/upgrade.

  Keep (don’t delete) the package directory when using remove/upgrade command.

  This will also try to preserve the directories ‘`${srcdir}`’ and ‘`${destdir}`’ when using build command. Its effect is available in recipes as ‘`${keep_srcdir}`’ and ‘`${keep_destdir}`’. See Special variables for details.

`-p`
`--prune`

  Prune conflicts.

`-P`
`--packagedir=<dir>`

  Set directory for package installations.

`-t`
`--targetdir=<dir>`

  Set target directory for symbolic links.

`-r`
`--rootdir=<dir>`

  Use the fully qualified named directory as the root directory for all qi operations.

  Note: the target directory and the package directory will be relative to the specified directory, excepting the graft log file.

Options when building software packages using recipes:

`-a`
`--architecture`

  Set architecture name for the package.

`-j`
`--jobs`

  Parallel jobs for the compiler.

  This option sets the variable ‘`${jobs}`’. If not specified, default sets to 1.

`-S`
`--skip-questions`

  Skip questions on completed recipes.

`-1`
`--increment`

  Increment release number (‘`${release}`’ + 1).

  The effect of this option will be omitted if –no-package is being used.

`-n`
`--no-package`

  Do not create a .tlz package.

`-i`
`--install`

  Install package after the build.

`-u`
`--upgrade`

  Upgrade package after the build.

`-o`
`--outdir=<dir>`

  Where the packages produced will be written.

  This option sets the variable ‘`${outdir}`’.

`-w`
`--worktree=<dir>`

  Where archives, patches, recipes are expected.

  This option sets the variable ‘`${worktree}`’.

`-s`
`--sourcedir=<dir>`

  Where compressed sources will be found.

  This option sets the variable ‘`${tardir}`’.

Other options:

`-v`
`--verbose`

  Be verbose (an extra -v gives more).

  It sets the verbosity level, default sets to 0.

  The value 1 is used for more verbosity while the value 2 is too detailed. Although at the moment it is limited to graft(1) verbosity.

`-N`
`--no-rc`

  Do not read the configuration file.

  This will ignore reading the qirc file.

`-L`
`--show-location`

  Print default directory locations and exit.

  This will print the target directory, package directory, working tree, the directory for sources, and the output directory for the packages produced.

`-h`
`--help`

  Display the usage and exit.

`-V`
`--version`

  This will print the (short) version information and then exit.

  The same can be achieved if Qi is invoked as ‘`qi version`’.

When FILE is -, qi can read from the standard input. See examples from the Packages section.

Exit status: 0 for a normal exit, 1 for minor common errors (help usage, support not available, etc), 2 to indicate a command execution error; 3 for integrity check error on compressed files, 4 for empty, not regular, or expected files, 5 for empty or not defined variables, 6 when a package already exist, 10 for network manager errors. For more details, see the Qi exit status section.

## 3 The qirc file

The global `qirc` file offers a way to define variables and tools (such as a download manager) for default use. This file is used by qi at runtime, e.g., to build, install, remove or upgrade packages.

Variables and their possible values must be declared as any other variable in the shell.

The command line options related to the package directory and target directory and some of the command line options used for the build command, have the power to override the values declared on `qirc`. See Invoking qi.

The order in which qi looks for this file is:

1. `${HOME}/.qirc` Effective user.
2. ‘`${sysconfdir}/qirc`’ System-wide.

If you intend to run qi as effective user, the file ‘`${sysconfdir}/qirc`’ could be copied to `${HOME}/.qirc` setting the paths for ‘`${packagedir}`’ and ‘`${targetdir}`’ according to the `$HOME`.

## 4 Packages

A package is a suite of programs usually distributed in binary form which may also contain manual pages, documentation, or any other file associated to a specific software.

The package format used by qi is a simplified POSIX pax archive compressed using lzip1. The file extension for packages ends in ‘`.tlz`’.

Both package installation and package de-installation are managed using two important (internal) variables: ‘`${packagedir}`’ and ‘`${targetdir}`’, these values can be changed in the configuration file or via options.

‘`${packagedir}`’ is a common directory tree where the package contents will be decompressed (will reside).

‘`${targetdir}`’ is a target directory where the links will be made by graft(1) taking ‘`${packagedir}/package_name`’ into account.

Packages are installed in self-contained directory trees and symbolic links from a common area are made to the package files. This allows multiple versions of the same package to coexist on the same system.

### 4.1 Package conflicts

All the links to install or remove a package are handled by graft(1). Since multiple packages can be installed or removed at the same time, certain conflicts may arise between the packages.

graft2 defines a CONFLICT as one of the following conditions:

- If the package object is a directory and the target object exists but is not a directory.
- If the package object is not a directory and the target object exists and is not a symbolic link.
- If the package object is not a directory and the target object exists and is a symbolic link to something other than the package object.

The default behavior of qi for an incoming package is to ABORT if a conflict arises. When a package is going to be deleted, qi tells to graft(1) to remove those parts that are not in conflict, leaving the links to the belonging package. This behavior can be forced if the –prune option is given.

### 4.2 Installing packages

To install a single package, simply type:

    qi install coreutils_8.30_i586-1@tools.tlz

To install multiple packages at once, type:

    qi install gcc_8.3.0_i586-1@devel.tlz rafaela_2.2_i586-1@legacy.tlz ...

Warn about the files that will be linked:

    qi warn bash_5.0_i586-1@shells.tlz

This is to verify the content of a package before installing it.

See the process of an installation:

    qi install --verbose mariana_3.0_i586-1@woman.tlz

A second –verbose or -v option gives more (very verbose).

Installing package in a different location:

    qi install --rootdir=/media/floppy lzip_1.21_i586-1@compressors.tlz

Important: the –rootdir option assumes ‘`${targetdir}`’ and ‘`${packagedir}`’. See the following example:

    qi install --rootdir=/home/selk lzip_1.21_i586-1@compressors.tlz

The content of "lzip_1.21_i586-1@compressors.tlz" will be decompressed into ‘`/home/selk/pkgs/lzip_1.21_i586-1@compressors`’. Assuming that the main binary for lzip is under ‘`/home/selk/pkgs/lzip_1.21_i586-1@compressors/usr/bin/`’ the target for "usr/bin" will be created at ‘`/home/selk`’. Considering that you have exported the `PATH` as ‘`${HOME}/usr/bin`’, now the system is able to see the recent lzip command.

Installing from a list of packages using standard input:

    qi install - < PACKAGELIST.txt

Or in combination with another tool:

    sort -u PACKAGELIST.txt | qi install -

The sort command will read and sorts the list of declared packages, while trying to have unique entries for each statement. The output produced is captured by Qi to install each package.

An example of a list containing package names is:

    /var/cache/qi/packages/amd64/tcl_8.6.9_amd64-1@devel.tlz
    /var/cache/qi/packages/amd64/tk_8.6.9.1_amd64-1@devel.tlz
    /var/cache/qi/packages/amd64/vala_0.42.3_amd64-1@devel.tlz

### 4.3 Removing packages

To remove a package, simply type:

    qi remove xz_5.2.4_i586-1@compressors.tlz

Remove command will match the package name using ‘`${packagedir}`’ as prefix. For example, if the value of ‘`${packagedir}`’ has been set to /usr/pkg, this will be equal to:

    qi remove /usr/pkg/xz_5.2.4_i586-1@compressors

Detailed output:

    qi remove --verbose /usr/pkg/xz_5.2.4_i586-1@compressors

A second –verbose or -v option gives more (very verbose).

By default the remove command does not preserve a package directory after removing its links from ‘`${targetdir}`’, but this behavior can be changed if the –keep option is passed:

    qi remove --keep /usr/pkg/lzip_1.21_i586-1@compressors

This means that the links to the package can be reactivated, later:

    cd /usr/pkg && graft -i lzip_1.21_i586-1@compressors

Removing package from a different location:

    qi remove --rootdir=/home/cthulhu xz_5.2.4_i586-1@compressors

Removing a package using standard input:

    echo vala_0.42.3_amd64-1@devel | qi remove -

This will match with the package directory.

### 4.4 Upgrading packages

The upgrade command inherits the properties of the installation and removal process. To make sure that a package is updated, the package is installed in a temporary directory taking ‘`${packagedir}`’ into account. Once the incoming package is pre-installed, qi can proceed to search and delete packages that have the same name (considered as previous ones). Finally, the package is re-installed at its final location and the temporary directory is removed.

Since updating a package can be crucial and so to perform a successful upgrade, from start to finish, you will want to ignore some important system signals during the upgrade process, those signals are SIGHUP, SIGINT, SIGQUIT, SIGABRT, and SIGTERM.

To upgrade a package, just type:

    qi upgrade gcc_9.0.1_i586-1@devel.tlz

This will proceed to upgrade "gcc_9.0.1_i586-1@devel" removing any other version of "gcc" (if any).

If you want to keep the package directories of versions found during the upgrade process, just pass:

    qi upgrade --keep gcc_9.0.1_i586-1@devel.tlz

To see the upgrade process:

    qi upgrade --verbose gcc_9.0.1_i586-1@devel.tlz

A second –verbose or -v option gives more (very verbose).

To force the upgrade of an existing package:

    qi upgrade --force gcc_9.0.1_i586-1@devel.tlz

#### 4.4.1 Package blacklist

To implement general package facilities, either to install, remove or maintain the hierarchy of packages in a clean manner, qi makes use of the pruning operation via graft(1) by default:

There is a risk if those are crucial packages for the proper functioning of the system, because it implies the deactivation of symbolic from the target directory, especially when transitioning an incoming package into its final location during an upgrade.

A blacklist of package names has been devised for the case where a user decides to upgrade all the packages in the system, or just the crucial ones, such as the C library.

The blacklist is related to the upgrade command only, consists in installing a package instead of updating it or removing previous versions of it; the content of the package will be updated over the existing content at ‘`${packagedir}`’, while the existing links from ‘`${targetdir}`’ will be preserved. A pruning of links will be carried out in order to re-link possible differences with the recent content, this helps to avoid leaving dead links in the target directory.

Package names for the blacklist to be declared must be set from the configuration file.

## 5 Recipes

A recipe is a file telling qi what to do. Most often, the recipe tells qi how to build a binary package from a source tarball.

A recipe has two parts: a list of variable definitions and a list of sections. By convention, the syntax of a section is:

    section_name()
    {
        section lines
    }

The section name is followed by parentheses, one newline and an opening brace. The line finishing the section contains just a closing brace. The section names or the function names currently recognized are ‘`build`’.

The ‘`build`’ section (or shell function) is an augmented shell script that contains the main instructions for building a software source.

### 5.1 Variables

A "variable" is a shell variable defined either in `qirc` or in a recipe to represent a string of text, called the variable’s "value". These values are substituted by explicit request in the definitions of other variables or in calls to external commands.

Variables can represent lists of file names, options to pass to compilers, programs to run, directories to look in for source files, directories to write output to, or anything else you can imagine.

Definitions of variables in qi have four levels of precedence. Options which define variables from the command-line override those specified in the `qirc` file, while variables defined in the recipe override those specified in `qirc`, taking priority over those variables set by command-line options. Finally, the variables have default values if they are not defined anywhere.

Options that set variables through the command-line can only reference variables defined in `qirc` and variables with default values.

Definitions of variables in `qirc` can only reference variables previously defined in `qirc` and variables with default values.

Definitions of variables in the recipe can only reference variables set by the command-line, variables previously defined in the recipe, variables defined in `qirc`, and variables with default values.

### 5.2 Special variables

There are variables which can only be set using the command line options or via `qirc`, there are other special variables which can be defined or redefined in a recipe. See the following definitions:

‘`outdir`’ is the directory where the packages produced are written. This variable can be redefined per-recipe. Default sets to ‘`/var/cache/qi/packages`’.

‘`worktree`’ is the working tree where archives, patches, and recipes are expected. This variable can not be redefined in the recipe. Default sets to ‘`/usr/src/qi`’.

‘`tardir`’ is defined in the recipe to the directory where the tarball containing the source can be found. The full name of the tarball is composed as ‘`${tardir}/$tarname`’. Its value is available in the recipe as ‘`${tardir}`’; a value of . for ‘`tardir`’ sets it to the value of CWD (Current Working Directory), this is where the recipe lives.

‘`arch`’ is the architecture to compose the package name. Its value is available in the recipe as ‘`${arch}`’. Default value is the one that was set in the Qi configuration.

‘`jobs`’ is the number of parallel jobs to pass to the compiler. Its value is available in the recipe as ‘`${jobs}`’. The default value is 1.

The two variables ‘`${srcdir}`’ and ‘`${destdir}`’ can be set in the recipe, as any other variable, but if they are not, qi uses default values for them when building a package.

‘`srcdir`’ contains the source code to be compiled, and defaults to ‘`${program}-${version}`’. ‘`destdir`’ is the place where the built package will be installed, and defaults to ‘`${TMPDIR}/package-${program}`’.

If ‘`pkgname`’ is left undefined, the special variable ‘`program`’ is assigned by default. If ‘`pkgversion`’ is left undefined, the special variable ‘`version`’ is assigned by default.

‘`pkgname`’ and ‘`pkgversion`’ along with: ‘`version`’, ‘`arch`’, ‘`release`’, and (optionally) ‘`pkgcategory`’ are used to produce the package name in the form: ‘`${pkgname}_${pkgversion}_${arch}-${release}[@${pkgcategory}].tlz`’

‘`pkgcategory`’ is an optional special variable that can be defined on the recipe to categorize the package name. If it is defined, then the package output will be composed as ‘`${pkgname}_${pkgversion}_${arch}-${release}[@${pkgcategory}.tlz`’. Automatically, the value of ‘`pkgcategory`’ will be prefixed using the ‘`@`’ (at) symbol which will be added to the last part of the package name.

A special variable called ‘`replace`’ can be used to declare package names that will be replaced at installation time.

The special variables ‘`keep_srcdir`’ and ‘`keep_destdir`’ are provided in order to preserve the directories ‘`${srcdir}`’ or ‘`${destdir}`’, if those exists as such. Note: The declaration of these variables are subject to manual deactivation; its purpose in recipes is to preserve the directories that relate to the package’s build (source) and destination directory, that is so that another recipe can get a new package (or meta package) from there. For example, the declarations can be done as:

    keep_srcdir=keep_srcdir
    keep_destdir=keep_destdir

Then from another recipe you would proceed to copy the necessary files that will compose the meta package, from the main function you must deactivate the variables at the end:

    unset keep_srcdir
    unset keep_destdir

This will leave the ’keep_srcdir’ and ’keep_destdir’ variables blank to continue with the rest of the recipes.

A typical recipe contains the following variables:

- ‘`program`’: Software name.

  It matches the source name. It is also used to compose the name of the package if ‘`${pkgname}`’ is not specified.

- ‘`version`’: Software version.

  It matches the source name. It is also used to compose the version of the package if ‘`${pkgversion}`’ is not specified.

- ‘`arch`’: Software architecture.

  It is used to compose the architecture of the package in which it is build.

- ‘`release`’: Release number.

  This is used to reflect the release number of the package. It is recommended to increase this number after any significant change in the recipe or post-install script.

- ‘`pkgcategory`’: Package category.

  Optional but recommended variable to categorize the package name when it is created.

Obtaining sources over the network must be declared in the recipe using the ‘`fetch`’ variable.

The variables ‘`netget`’ and ‘`rsync`’ can be defined in `qirc` to establish a network downloader in order to get the sources. If they are not defined, qi uses default values:

‘`netget`’ is the general network downloader tool, defaults sets to ‘`wget -c -w1 -t3 --no-check-certificate`’.

‘`rsync`’ is the network tool for sources containing the prefix for the RSYNC protocol, default sets to ‘`rsync -v -a -L -z -i --progress`’.

The variable ‘`description`’ is used to print the package description when a package is installed.

A description has two parts: a brief description, and a long description. By convention, the syntax of ‘`description`’ is:

    description="
    Brief description.

    Long description.
    "

The first line of the value represented is a brief description of the software (called "blurb"). A blank line separates the brief description from the long description, which should contain a more descriptive description of the software.

An example looks like:

    description="
    The GNU core utilities.

    The GNU core utilities are the basic file, shell and text manipulation
    utilities of the GNU operating system.  These are the core utilities
    which are expected to exist on every operating system.
    "

Please consider a length limit of 78 characters as maximum, because the same one would be used on the meta file creation. See The meta file section.

The ‘`homepage`’ variable is used to declare the main site or home page:

    homepage=http://www.gnu.org/software/gcc

The variable ‘`license`’ is used for license information3. Some code in the program can be covered by license A, license B, or license C. For "separate licensing" or "heterogeneous licensing", we suggest using | for a disjunction, & for a conjunction (if that ever happens in a significant way), and comma for heterogeneous licensing. Comma would have lower precedence, plus added special terms.

    license="LGPL, GPL | Artistic - added permission"

### 5.3 Writing recipes

Originally, Qi was designed for the version 3 of Dragora GNU/Linux; this doesn’t mean you can’t use it in another distribution, just that if you do, you’ll have to try it out for yourself. To help with this, here are some references to well-written recipes:

- http://git.savannah.nongnu.org/cgit/dragora.git/tree/recipes
- http://notabug.org/dragora/dragora/src/master/recipes
- http://notabug.org/dragora/dragora-extras/src/master/recipes
- http://git.savannah.nongnu.org/cgit/dragora/dragora-extras.git/tree/recipes

### 5.4 Building packages

A recipe is any valid regular file. Qi sets priorities for reading a recipe, the order in which qi looks for a recipe is:

1. Current working directory.
2. If the specified path name does not contain "recipe" as the last component. Qi will complete it by adding "recipe" to the path name.
3. If the recipe is not in the current working directory, it will be searched under ‘`${worktree}/recipes`’. The last component will be completed adding "recipe" to the specified path name.

To build a single package, type:

    qi build x-apps/xterm

Multiple jobs can be passed to the compiler to speed up the build process:

    qi build --jobs 3 x-apps/xterm

Update or install the produced package (if not already installed) when the build command ends:

    qi build -j3 --upgrade x-apps/xterm

Only process a recipe but do not create the binary package:

    qi build --no-package dict/aspell

The options –install or –upgrade have no effect when –no-package is given.

This is useful to inspect the build process of the above recipe:

qi build –keep –no-package dict/aspell 2>&1 | tee aspell-log.txt

The –keep option could preserve the source directory and the destination directory for later inspection. A log file of the build process will be created redirecting both, standard error and standard output to tee(1).

### 5.5 Variables from the environment

Qi has environment variables which can be used at build time:

The variable `TMPDIR` sets the temporary directory for sources, which is used for package extractions (see Examining packages) and is prepended to the value of ‘`${srcdir}`’ and ‘`${destdir}`’ in build command. By convention its default value is equal to ‘`/usr/src/qi/build`’.

The variables `QICFLAGS`, `QICXXFLAGS`, `QILDFLAGS`, and `QICPPFLAGS` have no effect by default. The environment variables such as `CFLAGS`, `CXXFLAGS`, `LDFLAGS`, and `CPPFLAGS` are unset at compile time:

Recommended practice is to set variables in the command line of ‘`configure`’ or make(1) instead of exporting to the environment. As follows:

http://www.gnu.org/software/make/manual/html_node/Environment.html

> It is not wise for makefiles to depend for their functioning on environment variables set up outside their control, since this would cause different users to get different results from the same makefile. This is against the whole purpose of most makefiles.

Setting environment variables for configure is deprecated because running configure in varying environments can be dangerous.

http://gnu.org/savannah-checkouts/gnu/autoconf/manual/autoconf-2.69/html_node/Defining-Variables.html

> Variables not defined in a site shell script can be set in the environment passed to configure. However, some packages may run configure again during the build, and the customized values of these variables may be lost. In order to avoid this problem, you should set them in the configure command line, using ‘`VAR=value`’. For example:

> `./configure CC=/usr/local2/bin/gcc`

http://www.gnu.org/savannah-checkouts/gnu/autoconf/manual/autoconf-2.69/html_node/Setting-Output-Variables.html

> If for instance the user runs ‘`CC=bizarre-cc ./configure`’, then the cache, config.h, and many other output files depend upon bizarre-cc being the C compiler. If for some reason the user runs ./configure again, or if it is run via ‘`./config.status --recheck`’, (See Automatic Remaking, and see config.status Invocation), then the configuration can be inconsistent, composed of results depending upon two different compilers. [...] Indeed, while configure can notice the definition of CC in ‘`./configure CC=bizarre-cc`’, it is impossible to notice it in ‘`CC=bizarre-cc ./configure`’, which, unfortunately, is what most users do. [...] configure: error: changes in the environment can compromise the build.

If the `SOURCE_DATE_EPOCH` environment variable is set to a UNIX timestamp (defined as the number of seconds, excluding leap seconds, since 01 Jan 1970 00:00:00 UTC.); then the given timestamp will be used to overwrite any newer timestamps on the package contents (when it is created). More information about this can be found at https://reproducible-builds.org/specs/source-date-epoch/.

### 5.6 The meta file

The "meta file" is a regular file created during the build command, it contains information about the package such as package name, package version, architecture, release, fetch address, description, and other minor data extracted from processed recipes. The name of the file is generated as ‘`${full_pkgname}.tlz.txt`’, and its purpose is to reflect essential information to the user without having to look inside the package content. The file format is also intended to be used by other scripts or by common Unix tools.

The content of a meta file looks like:

    #
    # Pattern scanning and processing language.
    #
    # The awk utility interprets a special-purpose programming language
    # that makes it possible to handle simple data-reformatting jobs
    # with just a few lines of code.  It is a free version of 'awk'.
    #
    # GNU awk implements the AWK utility which is part of
    # IEEE Std 1003.1 Shell and Utilities (XCU).
    #

    QICFLAGS="-O2"
    QICXXFLAGS="-O2"
    QILDFLAGS=""
    pkgname=gawk
    pkgversion=5.0.1
    arch=amd64
    release=1
    pkgcategory="tools"
    full_pkgname=gawk_5.0.1_amd64-1@tools
    blurb="Pattern scanning and processing language."
    homepage="http://www.gnu.org/software/gawk"
    license="GPLv3+"
    fetch="http://ftp.gnu.org/gnu/gawk/gawk-5.0.1.tar.lz"
    replace=""

Package descriptions are extracted from the variable ‘`description`’ where each line is interpreted literally and pre-formatted to fit in (exactly) 80 columns, plus the character ‘`#`’ and a blank space is prefixed to every line (shell comments).

In addition to the Special variables, there are implicit variables such as ‘`blurb`’:

The ‘`blurb`’ variable is related to the special variable ‘`description`’. Its value is made from the first (substantial) line of ‘`description`’, mentioned as the "brief description".

## 6 Order files

The order command has the purpose of resolving the build order through .order files. An order file contains a list of recipe names, by default does not perform any action other than to print a resolved list in descending order. For example, if a depends on b and c, and c depends on b as well, the file might look like:

    a: c b
    b:
    c: b

Each letter represents a recipe name, complete dependencies for the first recipe name are listed in descending order, which is printed from right to left, and removed from left to right:

OUTPUT

    b
    c
    a

Blank lines, colons and parentheses are simply ignored. Comment lines beginning with ‘`#`’ are allowed.

An order file could be used to build a series of packages, for example, if the content is:

    # Image handling libraries

    libs/libjpeg-turbo: devel/nasm
    x-libs/jasper: libs/libjpeg-turbo
    libs/tiff: libs/libjpeg-turbo

To proceed with each recipe, we can type:

    qi order imglibs.order | qi build --install -

The output of ‘`qi order imglibs.order`’ tells to qi in which order it should build the recipes:

    devel/nasm
    libs/libjpeg-turbo
    x-libs/jasper
    libs/tiff

## 7 Creating packages

The creation command is an internal function of qi to make new Qi compatible packages. A package is produced using the contents of the Current Working Directory and the package file is written out.

    Usage: qi create [Output/PackageName.tlz]...

The argument for the file name to be written must contain a fully qualified named directory as the output directory where the package produced will be written. The file name should be composed using the full name: name-version-architecture-release[@pkgcategory].tlz

EXAMPLE

    cd /usr/pkg
    cd claws-mail_3.17.1_amd64-1@x-apps
    qi create /var/cache/qi/packages/claws-mail_3.17.1_amd64-1@x-apps

In this case, the package "claws-mail_3.17.1_amd64-1@x-apps" will be written into ‘`/var/cache/qi/packages/`’.

All packages produced are complemented by a checksum file (.sha256).

## 8 Examining packages

The extraction command serves to examine binary packages for debugging purposes. It decompresses a package into a single directory, verifying its integrity and preserving all of it properties (owner and permission).

    Usage: qi extract [packagename.tlz]...

EXAMPLE

    qi extract mksh_R56c_amd64-1@shells.tlz

This action will put the content of "mksh_R56c_amd64-1@shells.tlz" into a single directory, this is a private directory for the user who requested the action, creation operation will be equal to u=rwx,g=,o= (0700). The package content will reside on this location, default mask to deploy the content will be equal to u=rwx,g=rwx,o=rwx (0000).

Note: the creation of the custom directory is influenced by the value of the `TMPDIR` variable.

## 9 Qi exit status

All the exit codes are described in this chapter.

‘`0`’

  Successful completion (no errors).

‘`1`’

  Minor common errors:

  - Help usage on illegal options or required arguments.
  - Program needed by qi (prerequisite) is not available.
‘`2`’

  Command execution error:

  This code is used to return the evaluation of an external command or shell arguments in case of failure.

‘`3`’

  Integrity check error for compressed files.

  Compressed files means:

  - A tarball file from tar(1). Supported extensions: .tar, .tar.gz, .tgz, .tar.Z, .tar.bz2, .tbz2, .tbz, .tar.xz, .txz
  - A tarball file from tarlz(1). Supported extensions: .tar.lz, .tlz
  - Zip files from unzip(1). Supported extensions: .zip, .ZIP
  - Gzip files from gzip(1). Supported extensions: .gz, .Z
  - Bzip2 files from bzip2(1). Supported extension: .bz2
  - Lzip files from lzip(1). Supported extension: .lz
  - Xz files from xz(1). Supported extension: .xz
‘`4`’

  File empty, not regular, or expected.

  It’s commonly expected:

  - An argument for giving commands.
  - A regular file or readable directory.
  - An expected extension: .tlz, .sha256, .order.
  - A protocol supported by the network downloader tool.
‘`5`’

  Empty or not defined variable:

  This code is used to report empty or undefined variables (usually variables coming from a recipe or assigned arrays that are tested).

‘`6`’

  Package already installed:

  The package directory for an incoming .tlz package already exists.

‘`10`’

  Network manager error:

  This code is used if the network downloader tool fails for some reason.

## Index

Jump to: | C E H I M P R S T V W

| Index Entry |  | Section

C |  |
| configuration file: |  | The qirc file

E |  |
| environment variables: |  | Recipes
| exit codes: |  | Qi exit status

H |  |
| handling build order: |  | Order files

I |  |
| introduction to qi: |  | Introduction to Qi
| invocation: |  | Invoking qi

M |  |
| managing packages: |  | Packages

P |  |
| package blacklist: |  | Packages
| package build: |  | Recipes
| package conflicts: |  | Packages
| package creation: |  | Creating packages
| package de-installation: |  | Packages
| package examination: |  | Examining packages
| package installation: |  | Packages
| package upgrade: |  | Packages

R |  |
| recipes: |  | Recipes

S |  |
| special variables: |  | Recipes

T |  |
| the meta file: |  | Recipes

V |  |
| variables: |  | Recipes

W |  |
| writing recipes: |  | Recipes

Jump to: | C E H I M P R S T V W

#### Footnotes

### (1)

For more details about tarlz and the lzip format, visit https://lzip.nongnu.org/tarlz.html.

### (2)

The official guide for Graft can be found at http://peters.gormand.com.au/Home/tools/graft/graft.html.

### (3)

The proposal for ‘`license`’ was made by Richard M. Stallman at http://lists.gnu.org/archive/html/gnu-linux-libre/2016-05/msg00003.html.